﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using TFlex;
using System.Reflection;
using Microsoft.Win32;

namespace WindowsFormsApplication20
{
    public partial class Form1 : Form
    {

        //Обработчик события , когда сборка отстуствует 
        static Assembly MyResolveEventHandler(object sender, ResolveEventArgs args)
        {
          
          
            if (args.Name.IndexOf("TFlexAPI3D") >= 0)
            {
                
                string pathTFlex = GetTFlexCADPath();
                if (pathTFlex.Length > 0)
                {
                    return Assembly.LoadFrom(pathTFlex + "\\Program\\TFlexAPI3D.dll");
                }
            }
            else if (args.Name.IndexOf("TFlexAPI") >= 0)
            {
                string pathTFlex = GetTFlexCADPath();
                if (pathTFlex.Length > 0)
                {
                    return Assembly.LoadFrom(pathTFlex + "\\Program\\TFlexAPI.dll");
                }
                
            }
            return null;
        }


        static string GetTFlexCADPath()
        {
            
            RegistryKey regKey = Registry.LocalMachine.OpenSubKey("SOFTWARE\\Top Systems\\");
            string[] allProduct = regKey.GetSubKeyNames();
            // Ищем просмоторщик
            RegistryKey regKeyProduct = regKey.OpenSubKey("T-FLEX Viewer 11.0\\Rus");
            string stPath = regKeyProduct.GetValue("SetupDirectory", "").ToString();
            //Ищем 2D
            regKeyProduct = regKey.OpenSubKey("T-FLEX CAD 2D 11.0\\Rus");
            stPath = regKeyProduct.GetValue("SetupDirectory", "").ToString();
            //Ищем 3D
            regKeyProduct = regKey.OpenSubKey("T-FLEX CAD 3D 11.0\\Rus");
            stPath = regKeyProduct.GetValue("SetupDirectory", stPath).ToString();
           // MessageBox.Show(stPath);
            return stPath;
        }

        public Form1()
        {
            InitializeComponent();
            //Установим обработчик событие , когда сборка отстуствует 
            AppDomain.CurrentDomain.AssemblyResolve += new ResolveEventHandler(MyResolveEventHandler);
            
            
            
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                GetTFlexCADPath();
                MyInitTFlex();
            }
            catch (Exception)
            {
                
                //throw;
            }
            
        }


        public bool MyInitTFlex()
        {

            try
            {
                ApplicationSessionSetup SessionSetup = new ApplicationSessionSetup();
                SessionSetup.EnableMacros = false;
                SessionSetup.ReadOnly = true;
                SessionSetup.PromptToSaveModifiedDocuments = false;
                SessionSetup.Enable3D = false;
                TFlex.Application.InitSession(SessionSetup);

            }
            catch (Exception)
            {

                return false;
            }  
                
            return true;
        }
    }
}
